{$R+,S+,Q+}

 Uses SysUtils;

 Procedure Assert(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'error!!!');
    Writeln(F,S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Wrong Answer');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure WA(B:Boolean);
  Begin
   WA(B,'');
  end;

 Procedure WA;
  Begin
   WA(True);
  end;

 Procedure Ok(B:Boolean;S:String);
  Var F:Text;
   Begin
    if (Not B) then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Ok');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure Ok(B:Boolean);
  Begin
    Ok(B,'');
  end;

 Procedure Ok;
  Begin
   Ok(True);
  end;

 Procedure PE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Presentation Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure PE(B:Boolean);
  Begin
   PE(B,'');
  end;

 Procedure PE;
  Begin
   PE(True);
  end;

 Procedure IE(B:Boolean;S:String);
  Var F:Text;
   Begin
    if Not B then Exit;
    Assign(F,ParamStr(4));
    ReWrite(F);
    Writeln(F,'Internal Error');
    if (Length(S) > 0) then Writeln(S);
    Close(F);
    Halt(0);
   end;

 Procedure IE(B:Boolean);
  Begin
   IE(B,'');
  end;

 Procedure IE;
  Begin
   IE(True);
  end;

 Type PList = ^TList;
      TList = Record
               V, S:LongInt;
               Next:PList;
              end;

 Const MinN = 2;
       MaxN = 32767;
       MinZ = 1;
       MaxZ = 65536;

 Var  Ans, Out, N:LongInt;
      A:Array[1..MaxN] of PList;
      B:Array[1..MaxN] of Boolean;

  Procedure InputData;
   Var F:Text;
       i, X, Y, Z:LongInt;

    Procedure AddEdge(X, Y, Z:LongInt);
     Var P:PList;
      Begin
       New(P);
       P^.V:=Y;
       P^.S:=Z;
       P^.Next:=A[X];
       A[X]:=P;
      end;

    Begin
     {$I-}
     Assign(F, ParamStr(1));
     Reset(F);
     IE(IOResult <> 0, 'File Not Found');
     Read(F, N);
     IE(IOResult <> 0);
     IE(Not Eoln(F));
     IE(N < MinN);
     IE(N > MaxN);
     Readln(F);
     For i:=1 to N - 1 do
      Begin
       Read(F, X);
       IE(IOResult <> 0);
       IE(SeekEoln(F));
       IE(X < 1);
       IE(X > N);
       Read(F, Y);
       IE(IOResult <> 0);
       IE(SeekEoln(F));
       IE(Y < 1);
       IE(Y > N);
       Read(F, Z);
       IE(IOResult <> 0);
       IE(Not Eoln(F));
       IE(Z < MinZ);
       IE(Z > MaxZ);
       Readln(F);
       AddEdge(X, Y, Z);
       AddEdge(Y, X, Z);
      end;
     IE(Not SeekEof(F));
     Close(F);
    end;

  Procedure ProcessData;
   Var F:Text;
       i:LongInt;

    Procedure Force(V:LongInt);
     Var P:PList;
      Begin
       B[V]:=True;
       P:=A[V];
       While P <> NIL do
        Begin
         if Not B[P^.V] then Force(P^.V);
         P:=P^.Next;
        end;
      end;

    Begin
     For i:=1 to N do B[i]:=False;
     Force(1);
     For i:=1 to N do IE(Not B[i]);
     {$I-}
     Assign(F, ParamStr(3));
     Reset(F);
     IE(IOResult <> 0, 'Answer File Not Found');
     Read(F, Ans);
     IE(IOResult <> 0);
     IE(Not SeekEof(F));
     Close(F);
     Assign(F, ParamStr(2));
     Reset(F);
     PE(IOResult <> 0);
     Read(F, Out);
     PE(IOResult <> 0);
     PE(Not SeekEof(F));
     Close(F);
     WA(Ans <> Out);
    end;

  Procedure OutputData;
   Begin
    Ok;
   end;

 Begin
  InputData;
  ProcessData;
  OutputData;
 end.
